﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace CSharpSA_SDKExample
{

    public enum TypeIdx
    {
        eAny = 0,
        eBSpline = 1,
        eCircle = 2,
        eCloud = 3,
        eScanStripCloud = 4,
        eCrossSectionCloud = 5,
        eCone = 6,
        eCylinder = 7,
        eDatum = 8,
        eEllipse = 9,
        eFrame = 10,
        eFrameSet = 11,
        eLine = 12,
        eParaboloid = 13,
        ePerimeter = 14,
        ePlane = 15,
        ePointGroup = 16,
        ePolySurface = 17,
        eScanStripeMesh = 18,
        eSlot = 19,
        eSphere = 20,
        eSurface = 21,
        eVectorGroup = 22,
        eSAReport = 23
    };
    public class SA_Type
    {
        public TypeIdx typeIdx = TypeIdx.eAny;

        public String[] typeNames = {"Any", "B-Spline", "Circle", "Cloud", "Scan Stripe Cloud",
                                    "Cross Section Cloud", "Cone", "Cylinder",  "Datum",
                                    "Ellipse", "Frame", "Frame Set", "Line", "Paraboloid", "Perimeter",
                                    "Plane", "Point Group", "Poly Surface",  "Scan Stripe Mesh", "Slot",
                                    "Sphere", "Surface", "Vector Group"};
        // Available options: 
        // "Any", "B-Spline", "Circle", "Cloud", "Scan Stripe Cloud", 
        // "Cross Section Cloud", "Cone", "Cylinder", "Datum", "Ellipse", 
        // "Frame", "Frame Set", "Line", "Paraboloid", "Perimeter", 
        // "Plane", "Point Group", "Poly Surface", "Scan Stripe Mesh", "Slot", 
        // "Sphere", "Surface", "Vector Group", 

        public SA_Type()
        {
            typeIdx = TypeIdx.eAny;
        }

        public SA_Type(TypeIdx idx)
        {
            typeIdx = (TypeIdx)idx;
        }

        public void SetType(TypeIdx idx)
        {
            typeIdx = idx;
        }

        public void SetType(string name)
        {
            int idx = 0;
            typeIdx = TypeIdx.eAny;
            foreach (string typename in typeNames)
            {
                idx++;
                if (typename == name)
                {
                    typeIdx = (TypeIdx)idx;
                    break;
                }
            }
        }

        public String GetTypeName()
        {
            return typeNames.ElementAt((int)typeIdx);
        }

        public String GetTypeName(TypeIdx idx)
        {
            return typeNames.ElementAt((int)idx);
        }
    }



 

}
